#include "Test.h"
#include "Vektor.h"

/** Es wird ein Vektor erzeugt und mit dem Wert 81
gefllt. Anschlieend wird geprft, ob auch jedes
Element den Wert 81 hat.
*/
bool testInit() {
   Vektor v;
   const int wert=81;
   const int vekSize = 4;
   Init(v, wert, vekSize);
   for (int i=0; i < vekSize; ++i)   {
      if (v.daten[i] != wert) {
         Free(v);
         return false;
      }
   }
   Free(v);
   return true;
}


/** Es werden zwei Vektoren erzeugt und mit 
den Werten 81 und -10 belegt. Nach Aufruf
von Add sollte der ergebnis-Vektor den
Wert 71 enthalten. 
*/
bool testPlus() {
   Vektor v1;
   const int vekSize = 4;
   const int wert1=81;
   Init(v1, wert1, vekSize);

   Vektor v2;
   const int wert2= -10;
   Init(v2, wert2, vekSize);

   Vektor result;
   Init(result, 0, vekSize);
   Plus(v1,  v2, result);

   for (int i=0; i < vekSize; ++i)   {
      if (result.daten[i] != (wert1+wert2)) {
         Free(v1); Free(v2); Free(result);
         return false;
      }
   }
   Free(v1); Free(v2); Free(result);
   return true;
}




/** Es wird ein Vektor mit 4 Elementen erzeugt
und mit dem Wert 80 gefuellt.
Anschliessend wird die Dimension des Vektors
auf 100 erhoeht und jedes Element mit 81 belegt.
Dann wird geprueft, ob auch jedes
der 100 Elemente den Wert 81 hat. */
bool testResize() {
   Vektor v;
   const int wert = 81;
   const int vekSize = 4;
   Init(v, wert - 1, vekSize);

   const int newVekSize = 100;
   Resize(v, newVekSize);
   Init(v, wert);
   for (int i = 0; i< newVekSize; ++i) {
      if (v.daten[i] != wert) {
         Free(v);
         return false;
      }
   }
   Free(v);
   return true;
}

